<?php

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 * Description of Desligamento
 *
 * @author carinaoliveira
 */
namespace Geral\Logic\FormularioEletronico;
use Setforms2\Runtime\Helper\Report\TkBirtReport;

class Desligamento {
   
    public static function getOpcoesAutoComplete($funcao) {
        $config = \TeknisaLib\Config\Config::getInstance();
        
        $opcoes = $config->{$funcao}();
        $opcoes = explode(';',$opcoes);
        foreach($opcoes as &$opcao){
              $opcao = array('VALUE' => ltrim($opcao), 'DESCRIPTION' => ltrim($opcao));              
        }        
        return $opcoes;        
    }
    
    public static function enviarEmail($emailOpe, $emailCC, $assunto,$anexo, $email)
    {
        $envio = \Setforms2\Shared\Notifier::factory();
        $notification = new \Setforms2\Shared\Business\Notification();
        
        $emailCC    = str_replace(array(';',' '), array(',', ''),$emailCC);
        $emCCDados  = explode(',', $emailCC);
        
        $email    = str_replace(array(';'), array(','),$email);
        $email    = str_replace(array(' '), array(''),$email);
        $email  = explode(',', $email);
        
        $images = '<img width = "152" height = "45" src="https://www.security.teknisa.com/_imagens/logtek.jpg" src="https://www.security.teknisa.com/_imagens/logtek.jpg"/>';
                
        $config = \TeknisaLib\Config\Config::getInstance();
        $anexo = $config -> getFormulariodesligamentoDesligamentoDir() . DIRECTORY_SEPARATOR . $anexo;
        $anexo = realpath($anexo);
        
        $mesageBody = '<img width = "152" height = "45" src="https://www.security.teknisa.com/_imagens/logtek.jpg" src="https://www.security.teknisa.com/_imagens/logtek.jpg"/>'
                            .'<br/><br/><strong>DESLIGAMENTO</strong><br/>'
                            .'<br/>Prezado(a), segue em anexo os dados de um desligamento!';      

        
            try 
            {
                //Com anexos e com CC
                if($anexo != '' && !(is_null($emailCC) || $emailCC == ''))
                {                  
                   $notification->setSubject($assunto);
                   $notification->setFrom($emailOpe);
                   $notification->setTo($email);
                   $notification->setCc($emCCDados);
                   $notification->setBody($mesageBody);                   
                   $notification->setAttachments(array($anexo));
                   $notification->setName('Teknisa Software LTDA');
                   $envio->setNotificationBusiness($notification);               
                }
                //Com anexos e sem CC
                elseif($anexo != '' && (is_null($emailCC) || $emailCC == '') )
                {
                   $notification->setSubject($assunto);
                   $notification->setFrom($emailOpe);
                   $notification->setTo($email);
                   $notification->setBody($mesageBody);
                   $notification->setAttachments(array($anexo));
                   $notification->setName('Teknisa Software LTDA');
                   $envio->setNotificationBusiness($notification);               
                }
                
                $envio->send();
                
            } catch (\Exception $e) {
                throw $e;
            }
    }
    
    public static function montaUrl($parametros) {
        foreach($parametros as &$parametro) {
                
                $parametro = self::tiraAcentos($parametro, true);
        }
        
        foreach($parametros as &$parametro) {
                
                $parametro = self::replaceSpecialChars($parametro, true);
        }
        
        $birt = TkBirtReport::getInstance();
        $birt->setReport('desligamento', TkBirtReport::REL_ESTATICO);            
        $birt->setParameterValuesFromArray($parametros, TkBirtReport::FORMAT_PDF);    
        $url = $birt->getUrl();
        
        return $url;       
    }
    
    public static function geraRelatorio($url, $file) {
        $fp = fopen ($file, 'w+');
        $ch = curl_init($url);
        curl_setopt_array($ch, array(
            CURLOPT_URL            => $url,
            CURLOPT_BINARYTRANSFER => 1,
            CURLOPT_RETURNTRANSFER => 1,
            CURLOPT_FILE           => $fp,
            CURLOPT_TIMEOUT        => 200,
            CURLOPT_USERAGENT      => 'Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)',
            CURLOPT_PROXY          => '192.168.122.3',
            CURLOPT_PROXYUSERPWD   => 'leandroafonso:teknisa1',
            CURLOPT_PROXYPORT      => 8080,
            CURLOPT_PROXYTYPE      => 'HTTP'
        ));

        if(curl_exec($ch) === false){
            echo 'Curl error: ' . curl_error($ch);
        }
        curl_close($ch);
        fclose($fp);        
    }
    
    public static function tiraAcentos($campo, $convertToURL = null) {
        //Array com possíveis caracteres com acento
        $caracteresAcento   = array('Ÿ', 'À', 'Á', 'Â', 'Ã', 'Ä', 'Ç', 'È', 'É', 'Ê', 'Ë', 'Ì', 'Í',
                               'Î', 'Ï', 'Ñ', 'Ò', 'Ó', 'Ô', 'Õ', 'Ö', 'Ù', 'Ú', 'Û', 'Ü', 'Ý', 
                               'à', 'á', 'â', 'ã', 'ä', 'ç', 'è', 'é', 'ê', 'ë', 'ì', 'í', 'î', 
                               'ï', 'ñ', 'ò', 'ó', 'ô', 'õ', 'ö', 'ù', 'ú', 'û', 'ü', 'ý', 'ÿ');
        
        //Array com caracteres sem acento
       $caracteresSemAcento = array('Y', 'A', 'A', 'A', 'A', 'A', 'C', 'E', 'E', 'E', 'E', 'I', 'I',
                               'I', 'I', 'N', 'O', 'O', 'O', 'O', 'O', 'U', 'U', 'U', 'U', 'Y',
                               'a', 'a', 'a', 'a', 'a', 'c', 'e', 'e', 'e', 'e', 'i', 'i', 'i',
                               'i', 'n', 'o', 'o', 'o', 'o', 'o', 'u', 'u', 'u', 'u', 'y', 'y');
       
        //Converte os caracteres com acento para caracteres sem acento 
        if ($convertToURL) {
            $campo = str_replace($caracteresAcento, $caracteresSemAcento, $campo);
        } else { //Converte caracteres sem acento para caracteres com acento
            $campo = str_replace($caracteresSemAcento, $caracteresAcento, $campo);
        }

        return $campo;
        
    }
    
    public static function replaceSpecialChars($campo, $convertToURL = null)
    {
        //Array com possíveis caracteres especiais
        $specialChar = array(' ', 'ƒ', '„', '…', '†', '‡', 'ˆ', '‰', 'Š', '‹', 'Œ', 'Ž', '‘', '’', 
                             '“', '”', '•', '–', '—', '˜', '™', 'š', '›', 'œ', 'ž', 'Ÿ', '¡', '¢', 
                             '£', '¤', '¥', '¦', '§', '¨', '©', 'ª', '«', '¬', '®', '¯', '°', '±',
                             '²', '³', '´', 'μ', '¶', '·', '¸', '¹', 'º', '»', '¼', '½', '¾', '¿',
                             'À', 'Á', 'Â', 'Ã', 'Ä', 'Å', 'Æ', 'Ç', 'È', 'É', 'Ê', 'Ë', 'Ì', 'Í',
                             'Î', 'Ï', 'Ð', 'Ñ', 'Ò', 'Ó', 'Ô', 'Õ', 'Ö', '×', 'Ø', 'Ù', 'Ú', 'Û', 
                             'Ü', 'Ý', 'Þ', 'ß', 'à', 'á', 'â', 'ã', 'ä', 'å', 'æ', 'ç', 'è', 'é', 
                             'ê', 'ë', 'ì', 'í', 'î', 'ï', 'ð', 'ñ', 'ò', 'ó', 'ô', 'õ', 'ö', '÷', 
                             'ø', 'ù', 'ú', 'û', 'ü', 'ý', 'þ', 'ÿ', chr(10));
        
        //Array com seus códigos em URL-encoding.
       $specialCharURL = array('%20', '%83', '%84', '%85', '%86', '%87', '%88', '%89', '%8A', '%8B',
                               '%8C', '%8E', '%91', '%92', '%93', '%94', '%95', '%96', '%97', '%98',
                               '%99', '%9A', '%9B', '%9C', '%9E', '%9F', '%A1', '%A2', '%A3', '%A4', 
                               '%A5', '%A6', '%A7', '%A8', '%A9', '%AA', '%AB', '%AC', '%AE', '%AF', 
                               '%B0', '%B1', '%B2', '%B3', '%B4', '%B5', '%B6', '%B7', '%B8', '%B9',
                               '%BA', '%BB', '%BC', '%BD', '%BE', '%BF', '%C0',	'%C1', '%C2', '%C3',	
                               '%C4', '%C5', '%C6', '%C7', '%C8', '%C9', '%CA',	'%CB', '%CC', '%CD',
                               '%CE', '%CF', '%D0', '%D1', '%D2', '%D3', '%D4', '%D5', '%D6', '%D7', 
                               '%D8', '%D9', '%DA', '%DB', '%DC', '%DD', '%DE', '%DF', '%E0', '%E1', 
                               '%E2', '%E3', '%E4', '%E5', '%E6', '%E7', '%E8', '%E9', '%EA', '%EB', 
                               '%EC', '%ED', '%EE', '%EF', '%F0', '%F1', '%F2', '%F3', '%F4', '%F5', 
                               '%F6', '%F7', '%F8', '%F9', '%FA', '%FB', '%FC', '%FD', '%FE', '%FF', '%0A');
       
        //Converter para URL-encoding.
        if ($convertToURL) {
            $campo = str_replace($specialChar, $specialCharURL, $campo);
        } else { //Converter para Texto.
            $campo = str_replace($specialCharURL, $specialChar, $campo);
        }

        return $campo;
    }
    
}

?>
